//+------------------------------------------------------------------+
//|                                                           11.mq5 |
//+------------------------------------------------------------------+
#include <Canvas\Canvas.mqh>
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   for(int i=1;i<5;i++)
     {ObjectDelete(0,(string)i);
     }
   
   uint r=ARGB(128,255,0,0);
   uint g=ARGB(128,0,255,0);
   uint b=ARGB(128,0,0,255);
   
   ulong t1=GetMicrosecondCount();
   {
   CCanvas ObjCanvas1;
   CCanvas ObjCanvas2;
   CCanvas ObjCanvas3;
   ObjCanvas1.CreateBitmapLabel("1",0,0,300,600,COLOR_FORMAT_ARGB_NORMALIZE);
   ObjCanvas2.CreateBitmapLabel("2",100,100,200,400,COLOR_FORMAT_ARGB_NORMALIZE);
   ObjCanvas3.CreateBitmapLabel("3",200,200,100,200,COLOR_FORMAT_ARGB_NORMALIZE);
   ObjCanvas1.Erase(r);
   ObjCanvas2.Erase(g);
   ObjCanvas3.Erase(b);
   ObjCanvas1.Update(false);
   ObjCanvas2.Update(false);
   ObjCanvas3.Update(false);
   }
   t1=GetMicrosecondCount()-t1;
   
   ulong t2=GetMicrosecondCount();
   {
   CCanvas ObjCanvas4;
   ObjCanvas4.CreateBitmapLabel("4",300,0,300,300,COLOR_FORMAT_ARGB_NORMALIZE);
   uint c1=Mixing(r,g);
   uint c2=Mixing(c1,b);
   ObjCanvas4.Erase(r);
   ObjCanvas4.FillRectangle(0,100,199,299,c1);
   ObjCanvas4.FillRectangle(0,200,99,299,c2);
   ObjCanvas4.Update(false);
   //ResourceSave(ObjCanvas4.ResourceName(),"resource4.bmp");
   }
   t2=GetMicrosecondCount()-t2;
   
   ulong t3=GetMicrosecondCount();
   {
   CCanvas ObjCanvas5;
   ObjCanvas5.CreateBitmapLabel("5",300,300,300,300,COLOR_FORMAT_ARGB_NORMALIZE);
   uint c1=Mixing1(r,g);
   uint c2=Mixing1(c1,b);
   for(uint i=0;i<300;i++)
     {for(uint j=0;j<300;j++)
        {ObjCanvas5.PixelSet(i,j,r);
        }
     }
   for(uint i=0;i<200;i++)
     {for(uint j=0;j<200;j++)
        {ObjCanvas5.PixelSet(i,j,c1);
        }
     }
   for(uint i=0;i<100;i++)
     {for(uint j=0;j<100;j++)
        {ObjCanvas5.PixelSet(i,j,c2);
        }
     }
   ObjCanvas5.Update(false);
   //ResourceSave(ObjCanvas5.ResourceName(),"resource5.bmp");
   }
   t3=GetMicrosecondCount()-t3;
   
   Comment(t1/2," ",t2," ",t3);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
uint Mixing1(uint below, uint above)
  {double Ca[4]={0}, Cb[4]={0}, C[4]={0};
   Ca[3]=uchar((above)>>24);//A
   Ca[0]=uchar((above)>>16);//R
   Ca[1]=uchar((above)>> 8);//G
   Ca[2]=uchar (above)     ;//B
   Cb[3]=uchar((below)>>24);//A
   Cb[0]=uchar((below)>>16);//R
   Cb[1]=uchar((below)>> 8);//G
   Cb[2]=uchar (below)     ;//B
   for(int i=0;i<4;i++)
     {C[i]=Cb[i]+(Ca[i]-Cb[i])*Ca[3];
      if(C[i]<0)   C[i]=0;
      if(C[i]>255) C[i]=255;
     }
   return((uchar(C[3])<<24)|(uchar(C[0])<<16)|(uchar(C[1])<<8)|uchar(C[2]));
  }

uint Mixing(uint below, uint above)
  {// C = ( Ca*Aa + Cb*Ab*(1-Aa) ) /A
   // A = Aa + Ab*(1-Aa)
   // A - alpha, C - color, a - above, b - below
   //---
   double Aa=0, Ab=0, A=0, Ca[3]={0}, Cb[3]={0}, C[3]={0};
   Aa   =uchar((above)>>24);//A
   Ca[0]=uchar((above)>>16);//R
   Ca[1]=uchar((above)>> 8);//G
   Ca[2]=uchar (above)     ;//B
   Ab   =uchar((below)>>24);//A
   Cb[0]=uchar((below)>>16);//R
   Cb[1]=uchar((below)>> 8);//G
   Cb[2]=uchar (below)     ;//B
   A=Aa+Ab*(1.-Aa/255.);
   if(A<0)   A=0;
   if(A>255) A=255;
   for(int i=0;i<3;i++)
     {C[i]=(Ca[i]*Aa+Cb[i]*Ab*(1.-Aa/255.))/A;
      if(C[i]<0)   C[i]=0;
      if(C[i]>255) C[i]=255;
     }
   //---
   return((uchar(A)<<24)|(uchar(C[0])<<16)|(uchar(C[1])<<8)|uchar(C[2]));
  }